/**************************************************************************
EASY MSc Dissertation - Project
Ken Webb
August 4, 2004
Application.h: interface for the Application class.

Application is an abstract class with two concrete subclasses:
  BacteriumApp and EnvironmentApp
From its superclass GlutWindow, it inherits the ability for an application
to have multiple Glut (OpenGL) graphics windows.
**************************************************************************/

#if !defined(AFX_APPLICATION_H__CB0FA995_4B07_4368_8B64_050B7F0B01E8__INCLUDED_)
#define AFX_APPLICATION_H__CB0FA995_4B07_4368_8B64_050B7F0B01E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GlutWindow.h"

class Application : public GlutWindow
{
public:
	Application();
	virtual ~Application();

	// inherited from GlutWindow superclass
	// subclasses should override and implement the functions that are needed
	virtual void CallBackDisplayFunc();
	virtual void CallBackIdleFunc(void);
	virtual void CallBackKeyboardFunc(unsigned char key, int x, int y);
	virtual void CallBackMotionFunc(int x, int y);
	virtual void CallBackMouseFunc(int button, int state, int x, int y);
	virtual void CallBackPassiveMotionFunc(int x, int y);
	virtual void CallBackReshapeFunc(int w, int h);   
	virtual void CallBackSpecialFunc(int key, int x, int y);
	virtual void CallBackTimerFunc(int value);
	virtual void CallBackVisibilityFunc(int visible);

	// not inherited from GlutWindow
	virtual void initialize( char *configFileName );
	virtual void readConfigFromFile( char *fileName );

	// Global Pause and Step; applies to all running apps
	static bool globalPause;
	static bool globalStep;
};

#endif // !defined(AFX_APPLICATION_H__CB0FA995_4B07_4368_8B64_050B7F0B01E8__INCLUDED_)
