/**************************************************************************
EASY MSc Dissertation - Project
Ken Webb
August 4, 2004
BactEnvPdu.h: interface for the BactEnvPdu class.

A Protocol Data Unit (PDU) is a message that can be exchanged between
instances of BacteriumApp and EnvironmentApp. A message has a required pduType,
and an optional pduVal. Messages are exchanged through queues.
**************************************************************************/

#if !defined(AFX_BACTENVPDU_H__658EC46E_F26C_4AD1_810F_E216B6FC6483__INCLUDED_)
#define AFX_BACTENVPDU_H__658EC46E_F26C_4AD1_810F_E216B6FC6483__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Bacterium Environment PDU Types
const char RunBPT    = 'R';
const char TumbleBPT = 'T';
const char GradientBPT = 'G'; // relative change in ligand gradient

// Bacterium Environment PDU
// PDU: Protocol Data Unit; a message
class BactEnvPdu  
{
public:
	BactEnvPdu();
	virtual ~BactEnvPdu();
	char pduType; // the type of this message or PDU; run, tumble, or gradient info
	int pduVal; // optional value carried by the PDU
};

#endif // !defined(AFX_BACTENVPDU_H__658EC46E_F26C_4AD1_810F_E216B6FC6483__INCLUDED_)
