/**************************************************************************
EASY MSc Dissertation - Project
Ken Webb
August 4, 2004
BacteriumProxy.h: interface for the BacteriumProxy class.

Proxy for a bacterium in the environment (EnvironmentApp).
All the internal complexity of a bacterium is abstracted away, and the
bacterium is represented as just an x,y position and a rotation angle.
**************************************************************************/

#if !defined(AFX_BACTERIUMPROXY_H__407C1132_F2A5_4353_B80B_8B5951E1190B__INCLUDED_)
#define AFX_BACTERIUMPROXY_H__407C1132_F2A5_4353_B80B_8B5951E1190B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class BacteriumProxy  
{
public:
	BacteriumProxy();
	virtual ~BacteriumProxy();
	int x; // current x postion
	int y; // current y position
	int rotated;
	float colorIntensity;
	// counts of times bacterium was in region with diff nums of ligands
	// used to produce a histogram
	int *ligCount;
	int initialX; // x position at start of simulation
	int initialY; // y position at start of simulation
};

#endif // !defined(AFX_BACTERIUMPROXY_H__407C1132_F2A5_4353_B80B_8B5951E1190B__INCLUDED_)
