/**************************************************************************
EASY MSc Dissertation - Project
Ken Webb
August 4, 2004
ProteinFactory.h: interface for the ProteinFactory class.

This is a convenience class, a friend of BacteriumApp.
It creates instances of Protein using the most common configuration.
**************************************************************************/

#if !defined(AFX_PROTEINFACTORY_H__06CFBE31_7E9C_4698_A4FF_1C8599DC7716__INCLUDED_)
#define AFX_PROTEINFACTORY_H__06CFBE31_7E9C_4698_A4FF_1C8599DC7716__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BacteriumApp.h"

// Protein Types
typedef enum proteinTypeEnum {
	// Chemotaxis proteins
	Tar_PT = 0, // 4 receptors
	Tsr_PT,
	Tap_PT,
	Trg_PT,
	CheW_PT,
	CheA_PT,
	CheY_PT,
	CheB_PT,
	CheR_PT,
	CheZ_PT,
	Motor_PT, // a complex of many proteins
	PhosTest_PT, // test phosphorylated protein
	SizeOfProteinEnumPT
} proteinTypeEnum;

class ProteinFactory  
{
public:
	ProteinFactory( BacteriumApp *b );
	virtual ~ProteinFactory();
	Protein* create( enum proteinTypeEnum pt, int x, int y, char *name = "Pr" );
protected:
	BacteriumApp *ba; // the instance of BacteriumApp that the proteins are created within
	static char *protStr[SizeOfProteinEnumPT]; // table of protein amino acid strings
	Protein *prot; // a convenience variable
};

#endif // !defined(AFX_PROTEINFACTORY_H__06CFBE31_7E9C_4698_A4FF_1C8599DC7716__INCLUDED_)
