/**************************************************************************
EASY MSc Dissertation - Project
Ken Webb
August 11, 2004
Rndm.cpp: implementation of the Rndm class.

**************************************************************************/

#include "Rndm.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Rndm::Rndm()
{

}

Rndm::~Rndm()
{

}

/////////////////////////////////////
// seedRandomNumberGenerator
// Seed the random number generator.
/////////////////////////////////////
void Rndm::seedRandomNumberGenerator( void )
{
	int seed;
	long ltime;
	time( &ltime );
	seed = ltime;
	srand( seed );
	rand(); // get rid of bad first random number
}

////////////////////////////////////////////////
// getRandomReal01
// Get a random real (double) >= 0.0 and < 1.0.
////////////////////////////////////////////////
double Rndm::getRandomReal01( void )
{
	return ((double)(rand() - 1) / (float)RAND_MAX);
}

////////////////////////////////////////////////////////
// getRandomInt
// Get a random integer between 0 and maxVal inclusive.
////////////////////////////////////////////////////////
int Rndm::getRandomInt( int maxVal )
{
	return getRandomInt( 0, maxVal );
}

/////////////////////////////////////////////////////////////
// getRandomInt
// Get a random integer between minVal and maxVal inclusive.
/////////////////////////////////////////////////////////////
int Rndm::getRandomInt( int minVal, int maxVal )
{
	double rVal = (double)(rand()) / (double)RAND_MAX;
	int rNum = (int)(rVal * (maxVal-minVal+1)) + minVal;
	// fix occasional problems when limits are reached
	if (rNum > maxVal)
		rNum = maxVal;
	return rNum;
}

///////////////////////////////////
// testRandom
// Test my random number routines.
///////////////////////////////////
void Rndm::testRandom( int minVal, int maxVal, int numIter )
{
	int rNum;
	for (int i = 0; i < numIter; i++) {
		rNum = getRandomInt( minVal, maxVal );
		printf( "%d\n", rNum );
	}
	printf( "\n" );
}
